// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:wyatt_deferred_widget_annotation/wyatt_deferred_widget_annotation.dart';
import 'package:wyatt_deferred_widget_annotation_example/widgets/my_awesome_widget1_deferred.dart';
import 'package:wyatt_deferred_widget_annotation_example/widgets/my_awesome_widget2_deferred.dart';
import 'package:wyatt_deferred_widget_annotation_example/widgets/my_awesome_widget3.dart';

void main(List<String> args) {
  Deferred.placeholderBuilder = (context) => const CircularProgressIndicator();
  runApp(const App());
}

class App extends StatelessWidget {
  const App({super.key});

  static const String title = 'Wyatt Deferred Widget Annotation Example';

  @override
  Widget build(BuildContext context) => MaterialApp(
        title: title,
        theme: ThemeData(
          primarySwatch: Colors.blue,
        ),
        home: Scaffold(
          appBar: AppBar(
            title: const Text(title),
          ),
          body: Builder(
            builder: (context) => ListView(
              children: [
                const MyAwesomeWidget3(),
                MyAwesomeWidget2Deferred(
                  placeholderSize: MediaQuery.of(context).size,
                ),
                MyAwesomeWidget1Deferred(
                  color: Colors.yellow,
                  placeholderBuilder: (context) =>
                      const LinearProgressIndicator(),
                ),
              ],
            ),
          ),
        ),
      );
}
